// C Source File
// Created 1/25/2004; 12.02.16

#define COMMENT_PROGRAM_NAME   "Quarridor 68K"
#define COMMENT_VERSION_STRING "beta vesion "
#define COMMENT_VERSION_NUMBER 0,3,2,0 /* major, minor, revision, subrevision */

#include <tigcclib.h>
#include "graphics.h"
#include "player.h"
#include "wall.h"
#include "globals.h"
#include "bitmaps.h"
#include "utils.h"

// Main Function
void _main(void)
{
	ClrScr();

	FontSetSys(F_4x6);

	ClrScr();
	if (!GrayOn())
		return;
		
	int linkid = -1;

	char done = 0;
	char quit = 0;
	
	short numPlayers = 2;
	short boardsize = MAX_SIZE;
	
	char charbuffer[26];

	int menu;

	mainmenu:

	DrawGrayScreen(title2, title1);	
	menu = mainmenu(&numPlayers);
	
	if(menu == 0) {
		GrayOff();
		return;
	}
	
	if (menu == 3)
	{
		DrawGrayScreen(title2, title1);
		optionsmenu(&boardsize);
		goto mainmenu;
	}
	
	if (menu == 2)
	{
		numPlayers = 2;
		boardsize = MAX_SIZE;
	
		SetPlane(0); ClrScr();
		SetPlane(1); ClrScr();

		char linkdata;


		linkdata = 42;
		DrawStr(0,0,"Pinging...", A_NORMAL);
		LIO_SendData(&linkdata, sizeof(char));
		
		linkid = 1;
		DrawStr(0,8,"Waiting for reply...", A_NORMAL);
		if (!LIO_RecvData(&linkdata,sizeof(char),20))
		{
			if (linkdata != 37) {
				quit=1;
			}
		}	
		else {
			linkid = 0;
			DrawStr(0,16,"Waiting for other calc...", A_NORMAL);
			int error = LIO_RecvData(&linkdata,sizeof(char),0);
			switch(error)
			{
				case 0:
					if (linkdata == 42) {
						linkdata = 37;
						LIO_SendData(&linkdata, sizeof(char));
					}
					else
						quit = 1;

					break;
				
				case 1:
					DrawStr(0,24,"ERR:No cable connected!", A_NORMAL);
					ngetchx();
					quit = 1;
					break;
					
				default:
					sprintf(charbuffer, "ERR: Code %d", error);
					DrawStr(0,24,charbuffer,A_NORMAL);
					ngetchx();
					quit = 1;
			}
		}
	
	}

		
	SetPlane(0); ClrScr();
	SetPlane(1); ClrScr();
	
	int i;

	const int maxWalls = (MAX_SIZE/2+1)*4;
	Wall wall[maxWalls];
	short numWalls = 0;
	
	Player player[4];
	setupPlayers(player, boardsize);

	drawBoard(boardsize);
	for (i=0; i<numPlayers; i++)
		drawPlayer(&player[i], i);
	

		
	int turn = 0;
	int key;
	
	int failure;

	int winners;	
	
	char strbuffer[9];
	
	sendMessage("Use arrows to move, F1 to place wall");

	for (i=0; i<numPlayers; i++)
	{
		sprintf(strbuffer, "Player %d:", i+1);
		SetPlane(1); DrawStr(100, 30+i*8, strbuffer, A_REPLACE);

		sprintf(strbuffer, "%d", player[i].wallsLeft);
		SetPlane(0); DrawStr(132, 30+i*8, strbuffer, A_REPLACE);
		SetPlane(1); DrawStr(132, 30+i*8, strbuffer, A_REPLACE);
		
		if (player[i].hasWon == 1) {
			SetPlane(0); DrawLine(100, 32+i*8, 136, 32+i*8, A_NORMAL); 
			SetPlane(1); DrawLine(100, 32+i*8, 136, 32+i*8, A_NORMAL); 
		}
	}
	
	char linkcommand[5];
	
	while (!done && !quit)
	{
	
		FontSetSys(F_4x6);
	
		SetPlane(0); DrawStr(100, 20, "Walls:", A_REPLACE);
		SetPlane(1); DrawStr(100, 20, "Walls:", A_REPLACE);
		
		XORsquare(player[turn].r, player[turn].c);
		if (linkid == -1 || linkid == turn) {
			GKeyFlush();
			key = ngetchx();	
			XORsquare(player[turn].r, player[turn].c);
		}

		failure = 1;		
	
		if (linkid == -1 || linkid == turn)
		{
		
			if (key == KEY_ESC) {
				quit = 1;
				if (linkid != -1) {
					linkcommand[0] = 0;
					LIO_SendData(&linkcommand, sizeof(char)*5);
				}
			}

			drawPlayer(&player[turn], turn);
			
			if (key == KEY_UP)
				failure = movePlayer(player, numPlayers, turn, boardsize, wall, numWalls, -1, 0);
			if (key == KEY_DOWN)
				failure = movePlayer(player, numPlayers, turn, boardsize, wall, numWalls, 1, 0);
			if (key == KEY_LEFT)
				failure = movePlayer(player, numPlayers, turn, boardsize, wall, numWalls, 0, -1);
			if (key == KEY_RIGHT)
				failure = movePlayer(player, numPlayers, turn, boardsize, wall, numWalls, 0, 1);
			drawPlayer(&player[turn], turn);
			
			if (!failure && linkid != -1)
			{
				linkcommand[0] = 1;
				linkcommand[1] = player[turn].r;
				linkcommand[2] = player[turn].c;
				
				LIO_SendData(&linkcommand, sizeof(char)*5);
			}
			
			if (key == KEY_F1 && player[turn].wallsLeft > 0) {
				failure = placeWall(wall, &numWalls, player, numPlayers, boardsize);
				if (!failure) {
					player[turn].wallsLeft--;
					if (linkid != -1)
					{
						linkcommand[0] = 2;
						linkcommand[1] = wall[numWalls-1].r;
						linkcommand[2] = wall[numWalls-1].c;
						linkcommand[3] = wall[numWalls-1].dir;
						linkcommand[4] = player[turn].wallsLeft;
						
						LIO_SendData(&linkcommand, sizeof(char)*5);
					}
				}
			}
			
		}
		else
		{
			sendMessage("Waiting for opponent...");
			
			if (!LIO_RecvData(&linkcommand,sizeof(char)*5,0))
			{
				XORsquare(player[turn].r, player[turn].c);
				drawPlayer(&player[turn], turn);
				switch (linkcommand[0])
				{
					case 0:	//other calc quits
						quit = 1;
				
					case 1:	//playermovement
						player[turn].r = linkcommand[1];
						player[turn].c = linkcommand[2];
						break;
					case 2: //wallplacement
						wall[numWalls].r = linkcommand[1];
						wall[numWalls].c = linkcommand[2];
						wall[numWalls].dir = linkcommand[3];

						drawWall(wall[numWalls].r, wall[numWalls].c, wall[numWalls].dir, A_NORMAL);
						
						numWalls++;
						player[turn].wallsLeft = linkcommand[4];
						break;
				}
				drawPlayer(&player[turn], turn);
				failure = 0;
			}
			else {
				quit = 1;
				break;
			}
			
			sendMessage("");
		}
				
		
		testIfPlayerWon(&player[turn], turn+1);
		
		winners = 0;
		
		if (!failure) {	//ok, so this is kind of messy, but I don't care, this demo was a 1 day hack
			
			for (i=0; i<numPlayers; i++)
				if (player[i].hasWon)
					winners++;

			if (winners < numPlayers-1) {
				do { //rotate players
					turn++;
					if (turn == numPlayers)
						turn = 0;
				} while (player[turn].hasWon);
			}
			else
			{
				sendMessage("Game over, press any key to quit");
				done=1;
			}

		}

		for (i=0; i<numPlayers; i++)
		{
			sprintf(strbuffer, "Player %d:", i+1);
			SetPlane(1); DrawStr(100, 30+i*8, strbuffer, A_REPLACE);

			sprintf(strbuffer, "%d", player[i].wallsLeft);
			SetPlane(0); DrawStr(132, 30+i*8, strbuffer, A_REPLACE);
			SetPlane(1); DrawStr(132, 30+i*8, strbuffer, A_REPLACE);
			
			if (player[i].hasWon == 1) {
				SetPlane(0); DrawLine(100, 32+i*8, 136, 32+i*8, A_NORMAL); 
				SetPlane(1); DrawLine(100, 32+i*8, 136, 32+i*8, A_NORMAL); 
			}
		}

	}
	
	if (!quit) {

		ngetchx();

		GrayOff();

		ClrScr();
		
		FontSetSys(F_6x8);
		DrawStr(0,0,"Version 0.3.2 beta", A_NORMAL);
		DrawStr(8,8,"fourth official release", A_NORMAL);
		DrawStr(0,20,"Please visit", A_NORMAL);
		DrawStr(8,28,"http://paulygon.org", A_NORMAL);
		DrawStr(0,36,"for updates.", A_NORMAL);
		DrawStr(0,60,"Written by Paul Houser", A_NORMAL);
		
		ngetchx();

	}


	
	GrayOff();

	//I am the walrus, goo goo g'joob
}


